function [prototype] =  imfuzzykmeanstrain(learningdata, classnb, stopthreshold, iterationnb, fuzzyness)

	macros = MACROS
	getf(macros+'verifyarguments.sci')
	
	// Read number of arguments
	[lhs, rhs] = argn(0)

	msg = ''

	// Verify number of arguments
	if rhs < 2
		error('Use : imfuzzykmeanstrain(learningdata, classnb [, stopthreshold [, iterationnb [, fuzzyness]]])')
	end

	[dim, msg] = verifyld(learningdata)
	if msg <> ''
		error(msg)
	end

	msg = verifync(classnb)
	if msg <> ''
		error(msg)
	end

	if rhs == 2
		prototype = fuzzykmeans_train(dim, learningdata, classnb, 0.001, 10, 2)

	elseif rhs == 3

		msg = verifyst(stopthreshold)
		if msg <> ''
			error(msg)
		end

		prototype = fuzzykmeans_train(dim, learningdata, classnb, stopthreshold, 10, 2)

	elseif rhs == 4

		msg = verifyst(stopthreshold)
		if msg <> ''
			error(msg)
		end

		msg = verifyinb(iterationnb)
		if msg <> ''
			error(msg)
		end

		prototype = fuzzykmeans_train(dim, learningdata, classnb, stopthreshold, iterationnb, 2)

	else

		msg = verifyst(stopthreshold)
		if msg <> ''
			error(msg)
		end

		msg = verifyinb(iterationnb)
		if msg <> ''
			error(msg)
		end

		msg = verifyfn(fuzzyness)
		if msg <> ''
			error(msg)
		end

		prototype = fuzzykmeans_train(dim, learningdata, classnb, stopthreshold, iterationnb, fuzzyness)

	end

endfunction

