function [hist]=imhist(image,step,mask,minimum,inter_nb)
	mode(-1);

	//set("figure_style", "new");
	
	// Read number of arguments
	[lhs,rhs] = argn(0);

	// Image size computing
	image_size=size(image);

	mat_type=type(image);

	// If no step is given default value 1 is used
	if rhs==1 then
		step=1;
	end

	// If no mask given
	if rhs<=2 then
		mask=ones(image_size(1),image_size(2));
	end

	mask_size=size(mask);
	// Verify that image and Mask have the same size
	if (image_size(1)<>mask_size(1)) | (image_size(2)<>mask_size(2)) then
		disp('Image and mask should have the same size!');
		hist='err';
		return;
	end

	if rhs<=3 then
		minimum=min(image);
		maximum=max(image)+step;
	end

	if rhs==4 then
		disp('Wrong number of rhs arguments!');
		hist='err';
		return;
	end

	if rhs==5 then
		maximum=minimum+inter_nb*step;
		if size(minimum,'*')<>1 then
			disp('min should have 1 as size!');
			hist='err';
			return;
		end
		if size(inter_nb,'*')<>1 then
			disp('inter_nb should have 1 as size!');
			hist='err';
			return;
		end

	end

	if mat_type==1 then
		[hist]=compute_hist(image(:,:),step,mask,minimum,maximum);
	else
		disp('Image should have only one plan!')
		hist='err';
		return;
	end
endfunction
