function [label_image,nb_objects]=imlabel(image,connectivity,vertical_parsing)
	mode(-1);

	// Verify if image is a binary one
	maximum=max(image);
	minimum=min(image);
	if (minimum<>0) | (maximum<>1) then
		disp('Image must be a binary image [0,1]!');
		label_image='err';
		nb_objects='err';
		return;
	end
	if max(abs(image-int(image)))<>0 then
		disp('Image should be an integer matrix!');
		label_image='err';
		nb_objects='err';
		return;
	end

	if type(image)==1 then
	
	// Read number of arguments
	[lhs, rhs] = argn(0);

	if rhs == 2
		vertical_parsing = 0;
	end;

	[label_image,nb_objects]=image_label(image(:,:),connectivity,vertical_parsing);
	else
		disp('Image should have only one plan!');
		label_image='err';
		nb_objects='err';
		return;
	end
endfunction
