function [threshold,discriminant]=imotsu(image,thresh_nb,mask)
	mode(-1);

	mat_type=type(image);
	image_size=size(image);

	// Verify if image is a matrix
	if mat_type<>1 then
		disp('Image should have only one plan!');
		threshold='err';
		discriminant='err';
		return;
	end

	// Verify if matrix values are integers
	if max(abs(image-int(image)))<>0 then
		disp('Image should be an integer matrix!');
		threshold='err';
		discriminant='err';
		return;
	end

	// In case of an image with negative values
	minimum=min(image);
	if (minimum<0) then
		image=image+abs(minimum);
	end

	// Read number of arguments
	[lhs,rhs] = argn(0);

	if rhs==1 then
		disp('Wrong number of arguments!');
		threshold='err';
		discriminant='err';
		return;
	end

	// If no mask given
	if rhs==2 then
		mask=ones(image_size(1),image_size(2));
	end

	[threshold,discriminant]=otsu_image(image(:,:),mask,thresh_nb);

	// In case of an image with negative values
	if (minimum<0) then
		threshold=threshold+minimum;
	end
endfunction
