function [LABimage] = imxyz2lab(XYZimage, Xn, Yn, Zn)

	// Read number of arguments
	[lhs,rhs] = argn(0);
	if rhs<>4 then
		disp('Wrong number of rhs arguments!');
		LABimage='err';
		return;
	end

	if size(Xn,'*')<>1 then
		disp('Xn should have 1 as size!');
		LABimage='err';
		return;
	end
	if size(Yn,'*')<>1 then
		disp('Yn should have 1 as size!');
		LABimage='err';
		return;
	end
	if size(Zn,'*')<>1 then
		disp('Zn should have 1 as size!');
		LABimage='err';
		return;
	end

	if type(XYZimage)<>17 then
		disp('Input image is not a color iamge!');
		LABimage='err';
		return;
	else
		[Limage Aimage Bimage] = computexyz2lab(XYZimage(:, :, 1), XYZimage(:, :, 2), XYZimage(:, :, 3), Xn, Yn, Zn);
		Lab = [Limage Aimage Bimage];
   		Lab_size = size(Lab)
   		LABimage = matrix(Lab, Lab_size(1), Lab_size(2)/3, 3);
	end
endfunction
