function [dilated_image]=imdilate(image,mykernel,mask)
	mode(-1);

	// Read number of arguments
	[lhs,rhs] = argn(0);

	image_size=size(image);
	dimension=size(image_size);

	mat_type=type(image);

	// Verify mask good definition
	if rhs<=2 then
		mask=ones(image_size(1), image_size(2));
	end
	mask_size=size(mask);

	if (mask_size(1)<>image_size(1)) | (mask_size(2)<>image_size(2)) then
		disp('Image and mask must have the same size!');
		dilated_image='err';
		return;
	end

	// Verify kernel good definition
	mykernel_size=size(mykernel);
	dimension=size(mykernel_size);
	if dimension<>[1 2] then
		disp('Bad kernel definition.')
		dilated_image='err';
	// Verify if kernel has odd dimensions
	elseif mykernel_size(1)-int(mykernel_size(1)/2)*2==0 then
		disp('Kernel must have odd dimensions.')
		dilated_image='err';
	elseif mykernel_size(2)-int(mykernel_size(2)/2)*2==0 then
		disp('Kernel must have odd dimensions.')
		dilated_image='err';
	elseif (mykernel_size(1)>=image_size(1)) | (mykernel_size(2)>=image_size(2)) then
		disp('Kernel is bigger than image!')
		dilated_image='err';
	else
		if mat_type==1 then
			dilated_image=image_dilate(image(:,:),mykernel(:,:), mask);
		else
			disp('The image to dilate should have only one plan!')
			dilated_image='err';
		end
	end
endfunction
