function [classes_image] =  imfuzzykmeansclassify(prototype, mask, weights, fuzzyness, image1, image2, image3, image4, image5, image6, image7, image8, image9, image10)

	getf(MACROS+'verifyarguments.sci')

	// Read number of arguments
	[lhs, rhs] = argn(0)

	msg = ''

	// Verify number of arguments
	if rhs < 5
		error('Use : imfuzzykmeansclassify(prototype, mask, weights, fuzzyness, image1 [, image2 [, image3 [, image4 [, image5, ...]]]]')
	end

	// Verify type and size of arguments
	[nbFunc, msg] = verifyweigths(weights, rhs-4)
	if msg <> ''
		error(msg)
	end

	msg = verifyfn(fuzzyness)
	if msg <> ''
		error(msg)
	end

	if nbFunc == 1
		[imageSize, imageDimension, msg] = verifyimages(image1)
	elseif nbFunc == 2
		[imageSize, imageDimension, msg] = verifyimages(image1,image2)
	elseif nbFunc == 3
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3)
	elseif nbFunc == 4
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4)
	elseif nbFunc == 5
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5)
	elseif nbFunc == 6
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6)
	elseif nbFunc == 7
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7)
	elseif nbFunc == 8
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7,image8)
	elseif nbFunc == 9
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7,image8,image9)
	else
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7,image8,image9, image10)
	end
	if msg <> ''
		error(msg)
	end

	[maskSize, maskDimension, mask, msg] = verifymask(mask, imageSize, imageDimension)
	if msg <> ''
		error(msg)
	end
	
	// Calculate the number of component for each pixel
	if  imageDimension == 4
		nbComp = imageSize(4)
	else
		nbComp = 1
	end

	msg = verifyproto(prototype, nbFunc, nbComp)
	if msg <> ''
		error(msg)
	end

	classes_image = []

	if nbFunc == 1
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1)
	elseif nbFunc == 2
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2)
	elseif nbFunc == 3
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3)
	elseif nbFunc == 4
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4)
	elseif nbFunc == 5
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4, image5)
	elseif nbFunc == 6
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4, image5, image6)
	elseif nbFunc == 7
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4, image5, image6, image7)
	elseif nbFunc == 8
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4, image5, image6, image7, image8)
	elseif nbFunc == 9
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4, image5, image6, image7, image8, image9)
	else
		classes_image = fuzzykmeans_classify(imageDimension, prototype, mask, weights, fuzzyness, image1, image2, image3, 									image4, image5, image6, image7, image8, image9, image10)
	end

endfunction





