function [prototype] =  imkmeanstrain(learningdata, classnb, stopthreshold, iterationnb)

	getf(MACROS+'verifyarguments.sci')

	// Read number of arguments
	[lhs, rhs] = argn(0)

	msg = ''

	// Verify number of arguments
	if rhs < 2
		error('Use : imkmeanstrain(learningdata, classnb [, stopthreshold [, iterationnb]])')
	end

	[dim, msg] = verifyld(learningdata)
	if msg <> ''
		error(msg)
	end

	msg = verifync(classnb)
	if msg <> ''
		error(msg)
	end

	if rhs == 2
		prototype = kmeans_train(dim, learningdata, classnb, 1E-10, 10)
	elseif rhs == 3

		msg = verifyst(stopthreshold)
		if msg <> ''
			error(msg)
		end

		prototype = kmeans_train(dim, learningdata, classnb, stopthreshold, 10)
	else

		msg = verifyst(stopthreshold)
		if msg <> ''
			error(msg)
		end

		msg = verifyinb(iterationnb)
		if msg <> ''
			error(msg)
		end

		prototype = kmeans_train(dim, learningdata, classnb, stopthreshold, iterationnb)
	end

endfunction


