function [lData] = imlearningdata(percentage, mask, weights, image1, image2, image3, image4, image5, image6, image7, 							image8, image9, image10)

	getf(MACROS+'verifyarguments.sci')

	// Read number of arguments
	[lhs, rhs] = argn(0)

	lData = []

	// Verify number of arguments
	if rhs < 4
		error('Use : imlearningdata(percentage, mask, weights, image1 [, image2 [, image3 [, image4 [, image5, ...]]]]')
	end

	// Verify type and size of arguments
	msg = verifyperc(percentage)
	if msg <> ''
		error(msg)
	end

	[nbFunc, msg] = verifyweigths(weights, rhs-3)
	if msg <> ''
		error(msg)
	end

	if nbFunc == 1
		[imageSize, imageDimension, msg] = verifyimages(image1)
	elseif nbFunc == 2
		[imageSize, imageDimension, msg] = verifyimages(image1,image2)
	elseif nbFunc == 3
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3)
	elseif nbFunc == 4
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4)
	elseif nbFunc == 5
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5)
	elseif nbFunc == 6
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6)
	elseif nbFunc == 7
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7)
	elseif nbFunc == 8
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7,image8)
	elseif nbFunc == 9
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7,image8,image9)
	else
		[imageSize, imageDimension, msg] = verifyimages(image1,image2,image3,image4,image5,image6,image7,image8,image9, image10)
	end
	if msg <> ''
		error(msg)
	end

	
	[maskSize, maskDimension, mask, msg] = verifymask(mask, imageSize, imageDimension)
	if msg <> ''
		error(msg)
	end

	// Calculate the number of component for each pixel
	if  imageDimension == 4
		nbComp = imageSize(4)
	else
		nbComp = 1
	end

	// Calculate the number of points that must be randomly generated
	nbPoints = ceil(percentage * sum(mask) / 100)


	if nbFunc == 1
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1)
	elseif nbFunc == 2
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2)
	elseif nbFunc == 3
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3)
	elseif nbFunc == 4
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4)
	elseif nbFunc == 5
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4, image5)
	elseif nbFunc == 6
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4, image5, image6)
	elseif nbFunc == 7
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4, image5, image6, image7)
	elseif nbFunc == 8
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4,image5, image6, image7, image8)
	elseif nbFunc == 9
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4, image5, image6, image7, image8, image9)
	else
		lData = learning_data(imageDimension, nbFunc, nbPoints, mask, weights, image1, image2, image3, image4, image5, image6, image7, image8, image9, image10)
	end

endfunction



