function [mask]=imroigreylevel(image,shape)
	mode(-1);
	
	// Image size
	image_size=size(image);
	width=image_size(1);
	height=image_size(2);
	choice=2;
	
	// Rectangular shape ROI
	if shape=='r' then
		while choice==2
			imshowgreylevel(image,0);
			
			// Red to draw
			xselect(); //Current window
			xset('pattern',addcolor([1,0,0]));
			[button,x_beg,y]=xclick();
			while ( (x_beg<0) | (y>height) | (y<=0) | (x_beg>=width)  | (button<>3)),[button,x_beg,y]=xclick();end
			y_beg=height-y;
			[button,x_end,y]=xclick();
			while ( (x_end<0) | (y>height) | (y<=0) | (x_end>=width)  | (button<>3)),[button,x_end,y]=xclick();end
			y_end=height-y;
			if x_beg>x_end then
				buffer=x_end;
				x_end=x_beg;
				x_beg=buffer;
			end
			if y_beg>y_end then
				buffer=y_end;
				y_end=y_beg;
				y_beg=buffer;
			end
			xrect([x_beg,height-y_beg,x_end-x_beg,y_end-y_beg]);
			xset('wshow');
			choice=x_message('Validate ROI ?',['Ok','Cancel']);
			xdel();
		end
		xsel=[x_beg;x_end];
		ysel=[y_beg;y_end];
		nb_pts=size(xsel);
		mask=createmask(shape,width,height,xsel,ysel,nb_pts(1));
	
	// Circular shape ROI
	elseif shape=='c' then
		choice=2;
		while choice==2
			imshowgreylevel(image,0);
			
			xset('pattern',addcolor([1,0,0]));
			xselect();
			[button,x_beg,y]=xclick();
			while ( (x_beg<0) | (y>height) | (y<=0) | (x_beg>=width)  | (button<>3)),[button,x_beg,y]=xclick();end
			y_beg=height-y;
			[button,x_end,y]=xclick();
			while ( (x_end<0) | (y>height) | (y<=0) | (x_end>=width)  | (button<>3)),[button,x_end,y]=xclick();end
			y_end=height-y;
			if x_beg>x_end then
				buffer=x_end;
				x_end=x_beg;
				x_beg=buffer;
			end
			if y_beg>y_end then
				buffer=y_end;
				y_end=y_beg;
				y_beg=buffer;
			end
			xarc(x_beg,height-y_beg,x_end-x_beg,x_end-x_beg,0,360*64);
			xset('wshow');
			choice=x_message('Validate ROI ?',['Ok','Cancel']);
			xdel();
		end
		xsel=[x_beg;x_end];
		ysel=[y_beg;y_end];
		nb_pts=size(xsel);
		mask=createmask(shape,width,height,xsel,ysel,nb_pts(1));
	
	// Ellipsoidal shape ROI
	elseif shape=='e' then
		choice=2;
		while choice==2
			imshowgreylevel(image,0);
			
			xset('pattern',addcolor([1,0,0]));
			xselect();
			[button,x_beg,y]=xclick();
			while ( (x_beg<0) | (y>height) | (y<=0) | (x_beg>=width) | (button<>3) ),[button,x_beg,y]=xclick();end
			y_beg=height-y;
			[button,x_end,y]=xclick();
			while ( (x_end<0) | (y>height) | (y<=0) | (x_end>=width) | (button<>3) ),[button,x_end,y]=xclick();end
			y_end=height-y;
			if x_beg>x_end then
				buffer=x_end;
				x_end=x_beg;
				x_beg=buffer;
			end
			if y_beg>y_end then
				buffer=y_end;
				y_end=y_beg;
				y_beg=buffer;
			end
			xarc(x_beg,height-y_beg,x_end-x_beg,y_end-y_beg,0,360*64);
			xset('wshow');
			choice=x_message('Validate ROI ?',['Ok','Cancel']);
			xdel();
		end
		xsel=[x_beg;x_end];
		ysel=[y_beg;y_end];
		nb_pts=size(xsel);
		mask=createmask(shape,width,height,xsel,ysel,nb_pts(1));
	
	// Polygonal shape ROI
	elseif shape=='p' then
		choice=2;
		while choice==2
			imshowgreylevel(image,0);
			
			xset('pattern',addcolor([1,0,0]));
			xselect();
			xsel=[]
			ysel=[]
			// Wait for first left clic
			[button,x_beg,y]=xclick();
			while ( (x_beg<0) | (y>height) | (y<=0) | (x_beg>=width) | (button<>3) ),[button,x_beg,y]=xclick();end
			xsel(1)=x_beg;
			ysel(1)=y;

			[button,x,y]=xclick();
			while ( (x<0) | (y>height) | (y<=0) | (x>=width) | (button<>3) ),[button,x,y]=xclick();end
			while (button<>5) // Wait for right clic
				while ( (x>=0)&(y<=height)&(y>0)&(x<width)&(button==3) )
					xsel=[xsel;x];
					ysel=[ysel;y];
					xpoly(xsel,ysel,'lines');
					xset('wshow');
					[button,x,y]=xclick();
				end
				if button<>5 then
					[button,x,y]=xclick();
				end
			end
			
		xpoly(xsel,ysel,'lines',1);
		xset('wshow');
		// Close the polygone
		xsel=[xsel;xsel(1)]
		ysel=[ysel;ysel(1)]
		choice=x_message('Validate ROI ?',['Ok','Cancel']);
		xdel();
		end
		nb_pts=size(xsel);
		mask=createmask(shape,width,height,xsel,ysel,nb_pts(1));
	
	// User defined shape ROI
	elseif shape=='u' then
		choice=2;
		while choice==2
			imshowgreylevel(image,0);
			
			xset('pattern',addcolor([1,0,0]));
			xselect();
			xsel=[]
			ysel=[]
			// Wait for first left clic on image
			rep=xgetmouse();
			while ( (rep(1)<0) | (rep(2)>height) | (rep(2)<=0) | (rep(1)>=width) | (rep(3)<>3) ),rep=xgetmouse();end
			xsel(1)=rep(1);
			ysel(1)=rep(2);
			
			rep=xgetmouse();
			while rep(3)<>3 // Wait for a left clic
				if((rep(1)>=0)&(rep(2)<=height)&(rep(2)>0)&(rep(1)<width)) then
					xsel=[xsel;rep(1)]
					ysel=[ysel;rep(2)]
				end
				rep=xgetmouse();
				xpoly(xsel,ysel,'lines');
				xset('wshow');
			end
		xpoly(xsel,ysel,'lines',1);
		xset('wshow');
		// Close line
		xsel=[xsel;xsel(1)]
		ysel=[ysel;ysel(1)]
		choice=x_message('Validate ROI ?',['Ok','Cancel']);
		xdel();
		end
		nb_pts=size(xsel);
		mask=createmask('p',width,height,xsel,ysel,nb_pts(1)); // Same function as polygonal shape
	else
		disp('ROI form unknown.');
		mask='err';
	end
	
	
endfunction
