function [filtered_image]=imshencastan(image,alpha,direction,filter_type,mask)
	mode(-1);

	// Read number of arguments
	[lhs,rhs] = argn(0);
	if rhs<4 then
		disp('Wrong number of arguments!');
		filtered_image='err';
		return;
	end

	if alpha<=0 | alpha>=1 then
		disp('Wrong alpha definition !');
		filtered_image='err';
		return;
	end

	if direction<>0 & direction<>45 & direction<>90 & direction<>135 then
		disp('Wrong direction parameter!');
		filtered_image='err';
		return;
	end

	if filter_type<>'f' & filter_type<>'g' then
		disp('Wrong filter type parameter!');
		filtered_image='err';
		return;
	end

	image_size=size(image);
	mat_type=type(image);

	// Verify mask good definition
	if rhs<=4 then
		mask = ones(image_size(1), image_size(2));
	end
	mask_size = size(mask);

	if (mask_size(1)<>image_size(1)) | (mask_size(2)<>image_size(2)) then
		disp('Image and mask must have the same size!');
		filtered_image='err';
		return;
	end


	if mat_type==1 then
		[filtered_image]=shencastan_image(image(:,:), alpha, direction, filter_type, mask);
	else
		disp('Image should have only one plan.')
		filtered_image='err';
	end
endfunction
