function []=imwrite(filename,image,fileformat,depth)
	mode(-1);

	// Read number of arguments
	[lhs, rhs] = argn(0);

	if rhs < 2 then
		disp('Please provide at least a filename and an image variable');
		return;
	else
		if rhs<3 then
			fileformat = 'PPM';
			depth = 8;
		else
			if rhs <4 then
				depth = 8;
			end;
		end;
	end;

	mat_type=type(image);

	if fileformat == 'PNG' then

			// Try to open the file to see if it exists
			[info, err]=fileinfo(filename);
			choice='yes';
			if err==0 then
				choice=input('File '+filename+' already exist, overwrite it? (default = yes)','s');
			end;

			// im256 called if image is 8 bits depth and has values above 255
			// im16b called if image is 16 bits depth and has values above 65535
			if (depth == 8) then
				if min(image)>=0 & max(image)<=255 then image_saved=int(image);
				else image_saved=im256(image);
				end;
			else
				if min(image)>=0 & max(image)<=65535 then image_saved=int(image);
				else image_saved=im16b(image);
				end;
			end;

			mat_type=type(image_saved);
			image_size=size(image);
			
			// Try to open the file to see if it exists
			if choice<>'no' then
				// A matrix = grey level image
				if mat_type==1 then
					write_png_gray(filename, image_saved, depth);
				//An hypermatrix = color image
				elseif mat_type==17 & image_size(3)==3 then
					write_png_rgb(filename, image_saved(:,:,1), image_saved(:,:,2), image_saved(:,:,3), depth);
				else
					disp('This hypermatrix is not a color image!');
				end
			end;

		return;
	else
		if (fileformat == 'PPM') | (fileformat == 'PGM') then

			// image with values between 0 and 255 : im256 not called
			if min(image)>=0 & max(image)<=255 then image_saved=int(image);
			else image_saved=im256(image);
			end

			mat_type=type(image_saved);
			image_size=size(image);

			// Try to open the file to see if it exists
			[info, err]=fileinfo(filename);
			choice='yes';
			if err==0 then
				choice=input('File '+filename+' already exist, overwrite it? (default = yes)','s');
			end;

			// Try to open the file to see if it exists
			if choice<>'no' then
				// A matrix = grey level image
				if mat_type==1 then
					write_pgm(filename, image_saved);
				//An hypermatrix = color image
				elseif mat_type==17 & image_size(3)==3 then
					write_ppm(filename, image_saved(:,:,1), image_saved(:,:,2), image_saved(:,:,3));
				else
					disp('This hypermatrix is not a color image!');
				end
			end

		end;
	end;

endfunction
